unit USB1;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  end;

type _lIn  = record
    bFunction : Byte;
    bValue1 : Byte;
    bValue2 : Byte;
    bValue3 : Byte;
end;

type _lOut  = record
    bAck : Byte;
    bValue1 : Byte;
    bValue2 : Byte;
    bValue3 : Byte;
end;
 

var
  Form1: TForm1;
  Temp : Real;

implementation

{$R *.DFM}

procedure Thermo;
var lIn: _lIn;
    lOut: _lOut;
    DeviceHandle: THandle;
    TemplateHandle: THandle;
    nBytes: DWord;
    bresult: Boolean;
begin
  DeviceHandle := CreateFile ('\\.\Thermometer_0',Generic_write,File_Share_write,nil,open_existing,0,TemplateHandle);
  lIn.bFunction := 11;   {Read Thermometer}
  bResult := DeviceIoControl(DeviceHandle,$04,@lIn,sizeof(lIn),@lOut,sizeof (lOut),nBytes,nil);
  Temp := lOut.bValue1/2;
  lIn.bFunction := 23;   {Write RAM}
  lIn.bValue1 := 47;     {Adr. 47 = Port 1}
  if Temp > 37 then   lIn.bValue2 := 0 else lIn.bValue2 := 15;
  bResult := DeviceIoControl(DeviceHandle,$04,@lIn,sizeof(lIn),@lOut,sizeof (lOut),nBytes,nil);
  CloseHandle (DeviceHandle);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Timer1.Interval := 100;
  Timer1.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Thermo;
  Edit1.Text := FloatToStrF(Temp,ffGeneral,3,2) + 'C';
end;

end.
